<%@ page pageEncoding="UTF-8" language="java"
	contentType="text/html;charset=UTF-8"%>
<%@ page
	import="org.apache.logging.log4j.LogManager, org.apache.log4j.Level,
org.apache.logging.log4j.core.LoggerContext   , org.apache.logging.log4j.core.config.LoggerConfig,
                 java.util.Map, java.util.HashMap, java.util.Collection, java.util.TreeSet"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<% long beginPageLoadTime = System.currentTimeMillis();%>

<!--
THE REASON THIS UTILITY WAS WRITTEN USING SCRIPLET AND NOT TAGS OR UTILS
WAS EASE OF INSTALLATION AND CONFIGURATION WAS THE HIGHEST PRIORITY ALONG
WITH THE LEAST NUMBER OF DEPENDANCIES.  THE ONLY THING THIS ADMIN UTILITY
REQUIRES IS A JSP ENGINE AND LOG4J.  NO CONFIGURATION IS REQUIRED EXCEPT
DROPPING IN THE JSP PAGE AND INVOKING IT THROUGH A STANDARD WEB BROWSER.

Originally written by Mike Amend, BEA Systems.
Adapted for Log4j2 by Henning Spjelkavik
Adapted to work with SailPoint IIQ by Alexander Jakomowic & Christopher Wessling

-->

<html>
<head>
<title>Log4J2 Administration</title>
<style type="text/css">
#content {
	margin: 0px;
	padding: 0px;
	text-align: center;
	background-color: #ddd;
	border: 1px solid #222;
	width: 100%;
	z-index: 10000
}

body {
	position: relative;
	margin: 10px; padding 0px;
	color: #333;
}

h1 {
	margin-top: 20px;
	font: 1.5em Verdana, Arial, Helvetica sans-serif;
}

h2 {
	margin-top: 10px;
	font: 0.75em Verdana, Arial, Helvetica sans-serif;
	text-align: left;
}

a, a:link, a:visited, a:active {
	color: red;
	text-decoration: none;
	text-transform: uppercase;
}

table {
	width: 100%;
	background-color: #000;
	padding: 3px;
	border: 0px;
}

th {
	font-size: 0.75em;
	background-color: #ccc;
	color: #000;
	padding-left: 5px;
	text-align: center;
	border: 1px solid #ccc;
	white-space: nowrap;
}

td {
	font-size: 0.75em;
	background-color: #fff;
	white-space: nowrap;
}

td.center {
	font-size: 0.75em;
	background-color: #fff;
	text-align: center;
	white-space: nowrap;
}
</style>
</head>
<body>
	<%

    String[] logLevels = {"trace", "debug", "info", "warn", "error", "fatal", "off" };

    String targetOperation   = (String)request.getParameter("operation");
    String targetLogger      = (String)request.getParameter("logger");
    String targetLogLevel    = (String)request.getParameter("newLogLevel");

    LoggerContext logContext = (LoggerContext) LogManager.getContext(false);
    Collection<org.apache.logging.log4j.core.Logger> loggers = logContext.getLoggers();
    
    Map<String, LoggerConfig> map = new HashMap();
    
    for(org.apache.logging.log4j.core.Logger log : loggers){
    	map.put(log.getName(),log.get());
    }

    if ("root".equals(targetLogger)) { targetLogger=""; }
	
    for (String loggerName : new TreeSet<String>(map.keySet())) {
        if("changeLogLevel".equals(targetOperation) && loggerName.startsWith(targetLogger))
        {
        	org.apache.log4j.Logger realLogger = org.apache.log4j.Logger.getLogger(loggerName);
        	realLogger.setLevel(org.apache.log4j.Level.toLevel(targetLogLevel.toUpperCase()));
           //logContext.updateLoggers();
        }	
    }
    
	loggers = logContext.getLoggers();
    
    for(org.apache.logging.log4j.core.Logger log : loggers){
    	map.put(log.getName(),log.get());
    }
	
%>
	<div id="content">
		<h1>
			Log4J2 Administration -
			<%=request.getServerName()%>
			(<%=request.getLocalName()%>)
		</h1>
		<table cellspacing="1">
			<tr>
				<th width="25%">Logger</th>
				<th width="25%">Parent Logger</th>
				<th width="15%">Effective Level</th>
				<th width="35%">Change Log Level To</th>
			</tr>


			<% for(String k : new TreeSet<String>(map.keySet())) {%>
			<%
            String loggerName = k;
            if (k.length()==0) { loggerName="root"; }
			org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger(k);
        %>
			<tr>
				<td><%= loggerName %></td>
				<td><%= logger.getParent() == null ? "" : logger.getParent().getName() %></td>
				<td><%= logger.getLevel() %></td>
				<td>
					<%
                    for(int cnt=0; cnt<logLevels.length; cnt++)
                    {
                        StringBuffer args = new StringBuffer();
                        args.append("operation=changeLogLevel&logger=" + loggerName);
                        args.append("&newLogLevel=" + logLevels[cnt]);
                        args.append("&template=templates/blanktemplate.jsp");

                        if(logger.getLevel() == org.apache.log4j.Level.toLevel(logLevels[cnt].toUpperCase()) )
                        {
                %> [<%=logLevels[cnt].toUpperCase()%>] <%
                }                  else                  {
                %> <a href='log4j2Admin.jsp?<%=args.toString()%>'>[<%=logLevels[cnt]%>]
				</a>&nbsp; <%
                        }
                    }
                %>
				</td>


			</tr>
			<%}%>


		</table>

		<h2>
			Page Load Time (Millis):
			<%=(System.currentTimeMillis() - beginPageLoadTime)%>
		</h2>

	</div>
</body>
</html>
